#!/bin/bash
#
# Shell script to check all the coding style check we have
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#  2 february 2014
# 27 february 2014
#  5 june     2014
# 2 oktober   2014
#
# where you have store the scripts and the awk-files
BIN=./
DIR=./
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
list=`ls ${WHERE}`
for eachFile in ${list}
do
  if [ -d ${eachFile} ] ;
  then
    # Is a directory
    if [ -r ${eachFile} ] ;
    then
      if [ -a ".no_coding_style" ] 
      then
        #echo "Datei .no_coding_file gefunden"
        exit
      fi
      if [ -a ".no_recursion" ] 
      then
        # do not explore the next directory(ies)
        touch .no_recursion
      else
        cd ${eachFile}
        ${nameOfTheScript} ${file_1}
        cd ..
      fi
    fi
  else
    if [ ! -e ${eachFile} ] ;
    then
      echo "no such file "${eachFile}
      exit
    fi
    # It is a file
    do_it="no"
    base_1=`basename ${eachFile} .h`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    base_1=`basename ${eachFile} .cpp`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    if [ ${do_it} == "yes" ] ;
    then
      ${BIN}/kernel.sh ${DIR}/Tabs.awk                           ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Trim.awk                           ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Twice.awk -v mode=check            ${eachFile}
      ${BIN}/kernel.sh ${DIR}/First.awk -v mode=check            ${eachFile}
      ${BIN}/kernel.sh ${DIR}/OneLine-If.awk -v mode=check       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/OneLine-Else.awk -v mode=check     ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Struct.awk -v mode=check           ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Pedantic.awk -v mode=check         ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Public.awk -v mode=check           ${eachFile}
      ${BIN}/kernel.sh ${DIR}/SpaceInclude.awk -v mode=check     ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Enum.awk -v mode=check             ${eachFile}
      ${BIN}/kernel.sh ${DIR}/EnumPedantic.awk -v mode=check     ${eachFile}
      ${BIN}/kernel.sh ${DIR}/NoSpace.awk -v mode=check          ${eachFile}
      ${BIN}/kernel.sh ${DIR}/SpaceComma.awk -v mode=check       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Default.awk -v mode=check          ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Switch.awk -v mode=check           ${eachFile}
      ${BIN}/kernel.sh ${DIR}/CommaAtEOL.awk -v mode=check       ${eachFile}
      ${BIN}/kernel.sh ${DIR}/If.awk -v mode=check               ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Else.awk -v mode=check             ${eachFile}
      ${BIN}/kernel.sh ${DIR}/For.awk -v mode=check              ${eachFile}
      ${BIN}/kernel.sh ${DIR}/While.awk -v mode=check            ${eachFile}
      ${BIN}/kernel.sh ${DIR}/TypedefStruct.awk -v mode=check    ${eachFile}
      ${BIN}/kernel.sh ${DIR}/Namespace.awk -v mode=check        ${eachFile}
      ${BIN}/kernel.sh ${DIR}/StarParenthesis.awk -v mode=check  ${eachFile}
      ${BIN}/kernel.sh ${DIR}/TwoBrace.awk -v mode=check         ${eachFile}
      ${BIN}/kernel.sh ${DIR}/TryCatch.awk -v mode=check         ${eachFile}
      ${BIN}/kernel.sh ${DIR}/ParenthesisAlone.awk -v mode=check ${eachFile}
      ${BIN}/SpaceAfter-check.sh                                 ${eachFile}
      ${BIN}/kernel.sh ${DIR}/CaseBrace.awk -v mode=check        ${eachFile}
    fi
  fi
done
