BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "Case-Brace.awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  # S_switchState may takes one of the next values
  S_normalLine        = 10;
  S_switchIsFound     = 11;
  S_caseIsFound       = 12; # after we must look for colon
  S_defaultIsFound    = 13; # after we must look for colon
  S_leftBraceIsFound  = 14;
  S_endOfBlockIsFound = 15;
  S_colonIsFound      = 16;

  S_switchState = S_normalLine;

  testIt = "no";
  #testIt ="yes";
  testItCB ="no";
  #testItCB ="yes";
} # end of BEGIN

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                              # separate local variables from real parameters by extra spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                              # separate local variables from real parameters by extra spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function RIndex(inLine,whatChar,    i, lengthOfTheInLine, character, lastPLace)
{                              # separate local variables from real parameters by extra spaces
  # looking for first "whatChar" character back from the end of the string "inLine"
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  lastPlace = 0;
  for (i = lengthOfTheInLine; i >= 1; i--) {
    character = substr(inLine, i, 1);
    if (character == whatChar) {
      lastPlace = i;
      break;
    }
  }
  return lastPlace;
}

function LookForColon(inLine,      lengthOfTheInLine, character, whereIsColon)
{                                # separate local variables from real parameters by extra spaces
  #if (testItCB == "yes") {
  #  printf("(86) NR=%d: inLine >%s<\n", NR, inLine);
  #}
  # look for Colon after case or default
  lengthOfTheInLine = length(inLine);
  #if (testItCB == "yes") {
  #  printf("(91) NR=%d: lengthOfTheInLine=%d\n", NR, lengthOfTheInLine);
  #}
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  character = substr(inLine, lengthOfTheInLine, 1);
  #if (testItCB == "yes") {
  #  printf("(98) NR=%d: character=%s\n", NR, character);
  #}
  if (character == ":") {
    #if (testItCB == "yes") {
    #  printf("(102) NR=%d: Return lengthOfTheInLine=%d\n", NR, lengthOfTheInLine);
    #}
    return lengthOfTheInLine;
  } else {
    if (testIt == "yes") {
      printf("look back to the :\n");
    }
    # look back to the :
    whereIsColon = RIndex(inLine, ":");
    if (whereIsColon > 0) {
      return whereIsColon;
    } else {
      return 0;
    }
  }
}

function CountBraces(inLine,      lengthOfTheInLine, character, i)
{                                # separate local variables from real parameters by extra spaces
  lengthOfTheInLine = length(inLine);
  i = 1;
  while (i <= lengthOfTheInLine) {
    character = substr(inLine, i, 1);
    switch (character) {
    case "{":
      braceCount = braceCount + 1;
      break;
    case "}":
      braceCount = braceCount - 1;
      break;
    default:
      break;
    }
    i = i + 1;
  }
  if (testItCB == "yes") {
    printf("(138) after: braceCount=%d\n", braceCount);
  }
}

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                              # separate local variables from real  parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d: ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(167)(%d)=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(198)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(203)partBeforeComment >%s<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(207)workLine >%s<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(213)restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(223)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(230)partBeforeComment >%s<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(234)workLine >%s<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(269)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(274)partBeforeString >%s<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(278)workLine >%s<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(284)restOfTheLine >%s<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(294)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(299)partBeforeString >%s<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(303)workLine >%s<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(309)restOfTheLine >%s<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(319)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(326)restOfTheLine >%s<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(341)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(348)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(355)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(362)workLine >%s<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(367)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(371)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(379)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(385)restOfTheLine >%s<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d: character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(417)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(422)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(429)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(436)workLine >%s<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(441)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(445)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(451)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d: character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(482)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(487)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(494)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(501)workLine >%s<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(506)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(510)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(516)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(524)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(537) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >%s<\n", workLine);
  }

  # look for Switch... Case... Brace
  if (testItCB == "yes") {
    printf("\n(547) NR=%d: look for Switch... Case... Brace ", NR);
    printf("in the workLine >%s<\n", workLine);
    printf("in the input line >%s<\n", theLine);
  }
  theOutLine = FirstSpaceAway(workLine);
  lengthOfTheRest = length(theOutLine);

  if (lengthOfTheRest > 0) {
    while (lengthOfTheRest > 0) {
      if (testItCB == "yes") {
        printf("(557) NR=%d: S_switchState= ", NR);
        switch (S_switchState) {
        case 10: printf("S_normalLine\n"); break;
        case 11: printf("S_switchIsFound\n"); break;
        case 12: printf("S_caseIsFound\n"); break;
        case 13: printf("S_defaultIsFound\n"); break;
        case 14: printf("S_leftBraceIsFound\n"); break;
        case 15: printf("S_endOfBlockIsFound\n"); break;
        case 16: printf("S_colonIsFound\n"); break;
        }
      }
      switch(S_switchState) {
      case 10: # S_normalLine:
        if (testItCB == "yes") {
          printf("(571) NR=%d: look for switch\n", NR);
        }
        whereIsSwitch = index(theOutLine, "switch ");
        if (whereIsSwitch == 1) {
          whereIsSwitch = index(workLine, "switch ");
          if (mode == "check") {
            theOldLine = workLine;
          }
          if (testItCB == "yes") {
            printf("(580) NR=%d: S_switchState changed to S_switchIsFound\n", NR);
          }
          if (mode == "change") {
            if (testItCB == "yes") {
              printf("(584) NR=%d: output it >%s<\n", NR, theLine);
            } else {
              printf("%s\n", theLine);
            }
          }
          S_switchState = S_switchIsFound;
          lengthOfTheRest = 0;
        } else {
          if (testItCB == "yes") {
            printf("(593) NR=%d: no switch found\n", NR);
          }
          if (mode == "change") {
            if (testItCB == "yes") {
              printf("(597) NR=%d: output it >%s<\n", NR, theLine);
            } else {
              printf("%s\n", theLine);
            }
          }
        }
        lengthOfTheRest = 0;
        break;
      case 11: # S_switchIsFound
        if (testItCB == "yes") {
          printf("(607) NR=%d: look for case[2], default[3] or rightBrace[]\n", NR);
        }
        # look for case[2]
        whereIsCase = index(theOutLine, "case ");
        if (whereIsCase == 1) {
          whereIsCaseDefault = index(workLine, "case ");
          if (mode == "check") {
            theOldLine = workLine;
          }
          if (testItCB == "yes") {
            printf("(617) NR=%d: S_switchState changed to S_caseIsFound\n", NR);
          }
          if (mode == "change") {
            if (testItCB == "yes") {
              printf("(621) NR=%d: output it >%s<\n", NR, theLine);
            } else {
              printf("%s\n", theLine);
            }
          }
          S_switchState = S_caseIsFound;
          temp = substr(theOutLine, 6);
          if (testItCB == "yes") {
            printf("(629) NR=%d: temp >%s<\n", NR, temp);
          }
          theOutLine = temp; 
        } else {
          if (testItCB == "yes") {
            printf("(634) NR=%d: no case found\n", NR);
          }
          if (testItCB == "yes") {
            printf("(637) NR=%d: look for default[3]\n", NR);
          }
          # look for default[3]
          whereIsDefault = index(theOutLine, "default");
          if (whereIsDefault == 1) {
            whereIsCaseDefault = index(workLine, "default");
            if ( testItCB == "yes") {
              printf("(644) NR=%d: default found\n", NR);
            }
            if (mode == "check") {
              theOldLine = workLine;
            }
            if (testItCB == "yes") {
              printf("(650) NR=%d: S_switchState changed to S_defaultIsFound\n", NR);
            }
            S_switchState = S_defaultIsFound;
            temp = substr(theOutLine, 8);
            if (testItCB == "yes") {
              printf("(655) NR=%d: temp >%s<\n", NR, temp);
            }
            theOutLine = temp; 
          } else {
            if (testItCB == "yes") {
              printf("(660) NR=%d: no default found\n", NR);
            }
            if (testItCB == "yes") {
              printf("(663) NR=%d: look for rightBrace[]\n", NR);
            }
            # look for rightBrace[]
            whereIsRightBrace = index(theOutLine, rightBrace);
            if (whereIsRightBrace == 1) {
              if ( testItCB == "yes") {
                printf("(669) NR=%d: rightBrace found\n", NR);
              }
              if (testItCB == "yes") {
                printf("(672) NR=%d: S_switchState changed to S_normalLine\n", NR);
              }
              braceCount = braceCount - 1;
              S_switchState = S_normalLine;
            } else {
              if (testItCB == "yes") {
                printf("(678) NR=%d: no rightBrace found\n", NR);
              }
            }
  
  ## TODO
            if (mode == "change") {
              if (testItCB == "yes") {
                printf("(685) NR=%d: output it >%s<\n", NR, theLine);
              } else {
                printf("%s\n", theLine);
              }
            }
            lengthOfTheRest = 0;
          }
        }
        break;
      case 12: # S_caseIsFound
      case 13: # S_defaultIsFound
        # look for colon[]
        if (testItCB == "yes") {
          printf("(698) NR=%d: look for colon[]\n", NR);
        }
        # check if the Colon is present
        if (testItCB == "yes") {
          printf("(702) NR=%d: theOutLine >%s<\n", NR, theOutLine);
        }
        # look for colon
        whereIsColon = LookForColon(theOutLine);
        if (whereIsColon > 0) {
          if (testItCB == "yes") {
            printf("(708) NR=%d: Colon found at %d\n", NR, whereIsColon);
          }
          if (testItCB == "yes") {
            printf("(711) NR=%d: S_switchState changed to S_colonIsFound\n", NR);
          }
          S_switchState = S_colonIsFound;
          aNewBlockIsUsed = "no";
          temp = substr(theOutLine, whereIsColon + 1);
          theOutLine = FirstSpaceAway(temp); 
          lengthOfTheRest = length(theOutLine);
          if (testItCB == "yes") {
            if (lengthOfTheRest == 0) {
              printf("(720) NR=%d: theOutLine is empty, OK\n", NR);
            } else {
              printf("(722) NR=%d: theOutLine >%s<\n", NR, theOutLine);
            }
          }
          caseNR = NR;
          caseLine = theLine;
        } else {
          printf("(728) NR=%d: Colon is missing XXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n", NR);
          lengthOfTheRest = 0;
        }
        break;
      case 14: # S_leftBraceIsFound
        if (testItCB == "yes") {
          printf("(734) NR=%d: a new Block\n", NR);
        }
        if (testItCB == "yes") {
          printf("(737) NR=%d: braceCount=%d\n", NR, braceCount);
        }
        if (braceCount > 1) {
          # other statment(s)[12]
          if (testItCB == "yes") {
            printf("(742) NR=%d: other statment(s)[12] %s\n", NR, theLine);
            printf("(743) NR=%d: count parenthesis and braces\n", NR);
          }
          CountBraces(theOutLine);
          if (testItCB == "yes") {
            printf("(747) NR=%d: braceCount=%d\n", NR, braceCount);
          }
          if (mode == "change") {
            printf("%s\n", theLine);
          }
          lengthOfTheRest = 0;
        } else {
          if (testItCB == "yes") {
            printf("(755) NR=%d: look for rightBrace[11], break[] or other statment(s)[12]\n", NR);
          }
          # look for rightBrace[11]
          whereIsRightBrace = index(theOutLine, rightBrace);
          if (whereIsRightBrace == 1) {
            whereIsRightBrace2 = index(workLine, rightBrace);
            if (testItCB == "yes") {
              printf("(762) NR=%d: rightBrace at %d, end of Block found\n", NR, whereIsRightBrace);
            }
            if (testItCB == "yes") {
              printf("(765) NR=%d: S_switchState changed to S_colonIsFound\n", NR);
            }
            S_switchState = S_colonIsFound;
            if (mode == "change") {
              sub("    ", "", theLine);
              printf("%s\n", theLine);
            }
            lengthOfTheRest = 0;
          } else {
            whereIsBreak = index(theOutLine, "break");
            if (whereIsBreak == 1) {
              if (testItCB == "yes") {
                printf("(777) NR=%d: break found in a new block, OK\n", NR);
              }
            } else {
              # other statment(s)[12]
              if (testItCB == "yes") {
                printf("(782) NR=%d: other statment(s)[12] %s\n", NR, theLine);
                printf("(783) NR=%d: count parenthesis and braces\n", NR);
              }
              CountBraces(theOutLine);
              if (testItCB == "yes") {
                printf("(787) NR=%d: braceCount=%d\n", NR, braceCount);
              }
              if (mode == "change") {
                printf("%s\n", theLine);
              }
            }
            lengthOfTheRest = 0;
          }
        }
        break;
      case 15: # S_endOfBlockIsFound
        break;
      case 16: # S_colonIsFound
        if (testItCB == "yes") {
          printf("(801) NR=%d: look for a new case[], a default[], a break[], ", NR);
          printf("a leftBrace[], a rightBrace[] or any other statement(s)[]\n", NR);
          printf("(803) NR=%d: in the theOutLine >%s<\n", NR, theOutLine);
        }
        # look for a new case[]
        whereIsCase = index(theOutLine, "case ");
        if (whereIsCase == 1) {
          if (testItCB == "yes") {
            printf("(809) NR=%d: case found\n", NR);
          }
          whereIsCaseDefault = index(workLine, "case ");
          if (mode == "check") {
            theOldLine = workLine;
          }
          if (testItCB == "yes") {
            printf("(816) NR=%d: S_switchState changed to S_caseIsFound\n", NR);
          }
          if (mode == "change") {
            if (testItCB == "yes") {
              printf("(820) NR=%d: output it >%s<\n", NR, theLine);
            } else {
              printf("%s\n", theLine);
            }
          }
          S_switchState = S_caseIsFound;
          temp = substr(theOutLine, 6);
          if (testItCB == "yes") {
            printf("(828) NR=%d: temp >%s<\n", NR, temp);
          }
          theOutLine = temp; 
        } else {
          if (testItCB == "yes") {
            printf("(833) NR=%d: no new case found\n", NR);
          }
          if (testItCB == "yes") {
            printf("(836) NR=%d: look for default[3]\n", NR);
          }
          # look for default[]
          whereIsDefault = index(theOutLine, "default");
          if (whereIsDefault == 1) {
            if (testItCB == "yes") {
              printf("(842) NR=%d: default found\n", NR);
            }
            whereIsCaseDefault = index(workLine, "default");
            if ( testItCB == "yes") {
              printf("default found(846), NR=%d\n", NR);
            }
            if (mode == "check") {
              theOldLine = workLine;
            }
            if (testItCB == "yes") {
              printf("(852) NR=%d: S_switchState changed to S_defaultIsFound\n", NR);
            }
            S_switchState = S_defaultIsFound;
            temp = substr(theOutLine, 8);
            if (testItCB == "yes") {
              printf("(857) NR=%d: temp >%s<\n", NR, temp);
            }
            theOutLine = temp; 
          } else {
            if (testItCB == "yes") {
              printf("(862) NR=%d: no default found\n", NR);
            }
            if (testItCB == "yes") {
              printf("(865) NR=%d: look for break[]\n", NR);
            }
            # look for break[]
            whereIsBreak = index(theOutLine, "break");
            if (whereIsBreak == 1) {
              if (testItCB == "yes") {
                printf("(871) NR=%d: break found\n", NR);
              }
              if (aNewBlockIsUsed == "yes") {
                if (mode == "check") {
                  printf("%d: %s\n", NR, theLine);
                  printf("the break may not be used after a new block\n");
                  printf("it must be used within the block\n");
                }
              }
              if (testItCB == "yes") {
                printf("(881) NR=%d: S_switchState changed to S_switchIsFound\n", NR);
              }
              S_switchState = S_switchIsFound;
              lengthOfTheRest = 0;
            } else {
              if (testItCB == "yes") {
                printf("(887) NR=%d: no break found\n", NR);
              }
              if (testItCB == "yes") {
                printf("(890) NR=%d: look for leftBrace[]\n", NR);
              }
              # look for leftBrace[]
              if (testItCB == "yes") {
                printf("(894) NR=%d: theOutLine >%s<\n", NR, theOutLine);
              }
              whereIsLeftBrace = index(theOutLine, leftBrace);
              if (whereIsLeftBrace == 1) {
                if (testItCB == "yes") {
                  printf("(899) NR=%d: leftBrace found\n", NR);
                }
                if ( caseNR < NR) {
                  if (mode == "check") {
                    printf("%d: %s\n", caseNR, caseLine);
                    printf("%d: %s\n", NR, theLine);
                    printf("%d: the left brace should be one line upper\n", NR);
                    exit;
                  }
                }
                if (testItCB == "yes") {
                  printf("(910) NR=%d: S_switchState changed to S_leftBraceIsFound\n", NR);
                }
                S_switchState = S_leftBraceIsFound;
                aNewBlockIsUsed = "yes";
                braceCount = braceCount + 1;
                if (testItCB == "yes") {
                  printf("(916) NR=%d: braceCount=%d\n", NR, braceCount);
                }
                lengthOfTheRest = 0;
              } else {
                if (testItCB == "yes") {
                  printf("(921) NR=%d: no leftBrace found\n", NR);
                }
                if (testItCB == "yes") {
                  printf("(924) NR=%d: look for rightBrace[]\n", NR);
                }
                # look for rightBrace[]
                if (testItCB == "yes") {
                  printf("(928) NR=%d: theOutLine >%s<\n", NR, theOutLine);
                }
                whereIsRightBrace = index(theOutLine, rightBrace);
                if (whereIsRightBrace == 1) {
                  if (testItCB == "yes") {
                    printf("(933) NR=%d: rightBrace found\n", NR);
                  }
                  S_switchState = S_normalLine;
                  lengthOfTheRest = 0;
                } else {
                  if (testItCB == "yes") {
                    printf("(939) NR=%d: no rightBrace found\n", NR);
                  }
                  if (testItCB == "yes") {
                    printf("(942) NR=%d: other statement(s)[] found\n", NR);
                  }
                  CountBraces(theOutLine);
                  if (testItCB == "yes") {
                    printf("(946) NR=%d: braceCount=%d\n", NR, braceCount);
                  }
                  if (mode == "change") {
                    if (testItCB == "yes") {
                      printf("(950) NR=%d: output it >%s<\n", NR, theLine);
                    } else {
                      printf("%s\n", theLine);
                    }
                  }
                  lengthOfTheRest = 0;
                }
              }
            }
          }
        }
        break;
      default:
        printf("(963) %d: WRONG VALUE for S_switchState=%d\n", NR, S_switchState);
        exit;
      } # switch(S_switchState)
    } # while (lengthOfTheRest > 0)
  } else {
    if (mode == "change") {
      if (testItCB == "yes") {
        printf("(970) NR=%d: ", NR);
      }
      printf("%s\n", theLine);
    }
  }
}
