#!/bin/bash
#
# Shell script to change all the coding style we have
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#  7 february 2014
# 27 february 2014
#  5 june     2014
# 2 oktober   2014
#
# where you have store the script and the awk-program
BIN=./
DIR=./
WHERE_DIFFS="/home/Diffs"
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
list=`ls ${WHERE}`
for eachFile in ${list}
do
  if [ -d ${eachFile} ] ;
  then
    # Is a directory
    if [ -r ${eachFile} ] ;
    then
      if [ -a ".no_coding_style" ] 
      then
        #echo "Datei .no_coding_file gefunden"
        exit
      fi
      if [ -a ".no_recursion" ] 
      then
        # do not explore the next directory(ies)
        touch .no_recursion
      else
        cd ${eachFile}
        ${nameOfTheScript} ${file_1}
        cd ..
      fi
    fi
  else
    # It is a file
    do_it="no"
    base_1=`basename ${eachFile} .h`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    base_1=`basename ${eachFile} .cpp`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    if [ ${do_it} == "yes" ] ;
    then
      pwd > pwd.txt
      # /home/guy-kde/projects/kdepimlibs/akonadi/contact/actions
      # 123456789=123456789=123456789=
      LAST_DIR=`cut --bytes=24- pwd.txt`
      # /home/guy-kde/src/5/kde/kdepimlibs/akonadi/autotests
      # 123456789=123456789=123456789=
      LAST_DIR=`cut --bytes=21- pwd.txt`
      rm pwd.txt
      #echo "LAST_DIR="${LAST_DIR}
      #echo "mkdir -p ${WHERE_DIFFS=}/${LAST_DIR}"
      mkdir -p ${WHERE_DIFFS}/${LAST_DIR}
      #
      # corrections for "switch" **before** astyle because of indentation(s)
      gawk -f ${DIR}/CaseBrace.awk --assign mode=change ${eachFile} > ${eachFile}-s
      mv ${eachFile}-s ${eachFile}
      #
      # look for {} and { ... } and change it
      gawk -f ${DIR}/TwoBrace.awk --assign mode=change ${eachFile} > ${eachFile}-b
      mv ${eachFile}-b ${eachFile}
      # lines with initialization(s)
      gawk -f ${DIR}/Default.awk --assign mode=change < ${eachFile} > ${eachFile}-d1
      mv ${eachFile}-d1 ${eachFile}
      #
      gawk -f ${DIR}/SpaceComma.awk --assign mode=change < ${eachFile} > ${eachFile}-s1
      mv ${eachFile}-s1 ${eachFile}
      #
      astyle \
          --style=otbs \
          --suffix=none \
          --formatted \
          --indent=spaces=4 \
          --indent-labels \
          --pad-header \
          --pad-oper \
          --unpad-paren \
          --align-pointer=name \
          --align-reference=name \
          --max-instatement-indent=80 \
          --min-conditional-indent=1 \
          ${eachFile}
          #--indent-cases \
          # --style=otbs       # Linux brackets, add brackets to all conditionals.
          # --suffix=none      # Do not retain a backup of the original file.
          # --formatted        # Display only the files that have been formatted.
          # --indent=spaces=4  # Indent using # spaces per indent.
          # --indent-labels    # Indent labels so that they appear one indent less
          #                    # than the current indentation level
      #
      # lines with namespace
      gawk -f ${DIR}/Namespace.awk --assign mode=change < ${eachFile} > ${eachFile}-n1
      mv ${eachFile}-n1 ${eachFile}
      #
      # lines with struct abc {
      gawk -f ${DIR}/Struct.awk --assign mode=change < ${eachFile} > ${eachFile}-n1
      mv ${eachFile}-n1 ${eachFile}
      #
      # correction for the SIGNAL and SLOT macros
      # qt5
      normalize --modify ${eachFile}
      #
#      # correction of normalize
#      gawk -f ${DIR}/Normalize-change.awk ${eachFile} > ${eachFile}-n
#      mv ${eachFile}-n ${eachFile}
      #
      # add <SPACE> vor ": public"
      gawk -f ${DIR}/Public.awk --assign mode=change ${eachFile} > ${eachFile}-p
      mv ${eachFile}-p ${eachFile}
      #
      # change "[ " to "[" and " ]" to "]"
      gawk -f ${DIR}/SpaceInArray.awk --assign mode=change ${eachFile} > ${eachFile}-k
      mv ${eachFile}-k ${eachFile}
      #
      # delete one line if two empties lines are present 
      gawk -f ${DIR}/Twice.awk --assign mode=change ${eachFile} > ${eachFile}-b
      mv ${eachFile}-b ${eachFile}
      #
      # delete first/last empty line(s)
      gawk -f ${DIR}/First.awk --assign mode=change ${eachFile} > ${eachFile}-c
      mv ${eachFile}-c ${eachFile}
      #
      # corrections for "enum"
      gawk -f ${DIR}/Enum.awk --assign mode=change ${eachFile} > ${eachFile}-e
      mv ${eachFile}-e ${eachFile}
      #
      # change <SPACE> after keyword
      ${BIN}/SpaceAfter-change.sh ${eachFile}
      #
      if [ -f "private_job" ] 
      then
        #echo "private job"
        . private_job
      fi
    fi
  fi
done
