BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "Public.awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  colonFound = "no";
  questionFound = "no";
  endOfInitializationFound = "no";
  firstPart = "yes";

  testIt ="no";
  #testIt ="yes";
  testDefault ="no";
  #testDefault ="yes";
  testSplit ="no";
  #testSplit ="yes";
} # end of BEGIN

function SplitComma(inLine, inparts,      numberOfCommas, numberOfParts, numberOfBraces, i, character, t1, t2)
{                              # separate local variables from real  parameters  by  extra  spaces
  numberOfCommas = 0;
  numberOfParts = 0;
  numberOfBraces = 0;
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  if (testSplit == "yes") {
    printf("\n");
    printf("(50) %d: inLine >%s<\n", NR, inLine);
  }
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    switch (character) {
    case "(":
      numberOfBraces += 1;
      break;
    case ")":
      numberOfBraces -= 1;
      break;
    case ",":
      if (numberOfBraces == 0) {
        # found a comma
        numberOfCommas += 1;
        commaAt[numberOfCommas] = i;
      }
      break;
    default:
      break;
    }
  }
  if (numberOfCommas > 0) {
    if (testSplit == "yes") {
      printf("(74) %d: numberOfCommas=%d\n", NR, numberOfCommas);
    }
    for (i = 1; i <= numberOfCommas; i++) {
      if (testSplit == "yes") {
        printf("(78) %d: commaAt[%d]=%d\n", NR, i, commaAt[i]);
      }
      if (i == 1) {
        # first comma
        if (commaAt[1] == 1) {
          numberOfParts = 0;
            if (commaAt[1] == lengthOfTheInLine) {
              # no more part
            } else {
              # one more part
              numberOfParts += 1;
              t1 = substr(inLine, commaAt[1] + 1);
              inparts[numberOfParts] = FirstAwayTrim(t1);
            }
        } else {
          # first comma NOT at 1
          numberOfParts = 1;
          t1 = substr(inLine, 1, commaAt[1] - 1);
          inparts[1] = FirstAwayTrim(t1);
          if (numberOfCommas == 1) {
            # also last comma
            if (commaAt[1] == lengthOfTheInLine) {
              # no more part
            } else {
              # last part
              numberOfParts += 1;
              t1 = substr(inLine, commaAt[1] + 1);
              inparts[numberOfParts] = FirstAwayTrim(t1);
            }
          }
        }
      } else {
        if (i == numberOfCommas) {
          # last comma
          if (commaAt[numberOfCommas] == lengthOfTheInLine) {
            # no more part
          } else {
            # part before last part
            numberOfParts += 1;
            from = commaAt[i - 1] + 1;
            until = commaAt[i] - 1;
            howMany = until - from + 1;
            t1 = substr(inLine, from, howMany);
            inparts[numberOfParts] = FirstAwayTrim(t1);
            # last part
            numberOfParts += 1;
            t1 = substr(inLine, commaAt[i] + 1);
            inparts[numberOfParts] = FirstAwayTrim(t1);
          }
        } else {
          # one more part, between two commas
          numberOfParts += 1;
          from = commaAt[i - 1] + 1;
          until = commaAt[i] - 1;
          howMany = until - from + 1;
          t1 = substr(inLine, from, howMany);
          inparts[numberOfParts] = FirstAwayTrim(t1);
        }
      }
    }
  } else {
    if (testSplit == "yes") {
      printf("(140) %d: no comma found\n", NR);
    }
    numberOfParts = 1;
    inparts[1] = FirstAwayTrim(inLine);
  }
  if (testSplit == "yes") {
    printf("(146) %d: numberOfParts=%d\n", NR, numberOfParts);
    if (numberOfParts > 0) {
      for (i = 1; i <= numberOfParts; i++) {
        printf("(149) %d: inparts[%d]>%s<\n", NR, i, inparts[i]);
      }
    }
  }
  if (testSplit == "yes") {
    printf("\n");
  }
  return numberOfParts;
}

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstAwayTrim(inLine,    t1, outLine)
{                              # separate local variables from real  parameters  by  extra  spaces
  t1 = FirstSpaceAway(inLine);
  outLine = TrimLine(t1);
  return outLine;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                              # separate local variables from real  parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(213)(%d)=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      default:
        printf("(226) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
        exit;
      }
    }
    switch (switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1=%d\n", whereIsComment_1);
        printf("whereIsComment_2=%d\n", whereIsComment_2);
        printf("whereIsString_1=%d\n", whereIsString_1);
        printf("whereIsString_2=%d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(247)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(252)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(256)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(262)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2=%d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(272)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(279)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(283)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1=%d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2=%d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1=%d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2=%d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(318)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(323)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(327)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(333)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2=%d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(343)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(348)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(352)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(358)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective=%d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(368)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(375)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(390)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(397)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(404)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(411)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(416)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(420)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(428)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(434)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character at %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(466)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(471)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(478)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(485)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(490)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(494)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(500)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character at %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(531)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(536)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(543)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(550)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(555)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(559)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(565)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(573)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(586) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch (switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }

  # look for : ? ; leftBrace
  restOfTheLine = FirstAwayTrim(workLine);
  lengthOfTheRest = length(restOfTheLine);
  where = 1;
  found = "no";
  if (testDefault == "yes") {
    printf("\n");
    printf("(601) %d: Input line    >%s<\n", NR, theLine);
    printf("(602) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
  }

  # look for case xyz:
  whereIsCase = index(workLine, "case ");
  if (whereIsCase > 0) {
    # this is a "case ..." line, don't do anything here
    if (mode == "change") {
      if (testDefault == "yes") {
        printf("(611) %d", NR);
      }
      printf("%s\n", theLine);
    }
  } else {
    # look for public
    whereIsPublic = index(workLine, "public");
    if (whereIsPublic > 0) {
      # this is a "public ..." line, don't do anything here
      if (mode == "change") {
        if (testDefault == "yes") {
          printf("(622) %d", NR);
        }
        printf("%s\n", theLine);
      }
    } else {
      # the JOB
      numberOfBraces = 0;
      while (where <= lengthOfTheRest && (found == "no")) {
        letter = substr(restOfTheLine, where, 1);
        #if (testDefault == "yes") {
        #  printf("(632) %d: where=%d, letter >%s<\n", NR, where, letter);
        #}
        switch (letter) {
        case "(":
          numberOfBraces += 1;
          break;
        case ")":
          numberOfBraces -= 1;
          break;
        case ":":
          if (numberOfBraces == 0) {
            if (questionFound == "no") {
              # only if we don't found any ?
              letter2 = substr(restOfTheLine, where + 1, 1);
              if (letter2 == ":") {
                # it is ::
                where += 1;
              } else {
                if (testDefault == "yes") {
                  printf("(651) %d: Colon found for line >%s<\n", NR, theLine);
                }
                colonFound = "yes";
                found = "yes";
                position = where;
              }
            }
          }
          break;
        case "?":
          if (numberOfBraces == 0) {
            if (colonFound == "no") {
              # only if we don't found any :
              questionFound = "yes";
              #found = "yes";
              position = where;
            }
          }
          break;
        case ";":
          if (questionFound == "yes") {
            # look for the end of the statement
            found = "yes";
            questionFound = "no";
            if (testDefault == "yes") {
              printf("(676) %d: End of the statement found\n", NR);
            }
          }
          break;
        case "{":
          if (colonFound == "yes") {
            # look for the end of the initialization
            found = "yes";
            endOfInitializationFound = "yes";
            if (testDefault == "yes") {
              printf("(686) %d: End of the initialization found\n", NR);
            }
          }
          break;
        default:
          break;
        }
        where += 1;
      }
      # may be some corrections must be done because of "protected", "private"
      if (colonFound == "yes") {
        if (testDefault == "yes") {
          printf("(698) %d: Colon found for line >%s<\n", NR, theLine);
        }
        # look for "protected"
        whereIsProtected = index(restOfTheLine, "protected");
        if (whereIsProtected > 0) {
          if (testDefault == "yes") {
            printf("(704) %d: correction because of \"protected\" found for line >%s<\n", NR, theLine);
          }
          colonFound = "no";
          where = 0;
          position = 0;
        }
        # look for "private"
        whereIsProtected = index(restOfTheLine, "private");
        if (whereIsProtected > 0) {
          if (testDefault == "yes") {
            printf("(714) %d: correction because of \"private\" found for line >%s<\n", NR, theLine);
          }
          colonFound = "no";
          where = 0;
          position = 0;
        }
      }
      if (colonFound == "yes") {
        if (endOfInitializationFound == "no") {
          if (testDefault == "yes") {
            printf("(724) %d: endOfInitializationFound is no\n", NR);
          }
          if (firstPart == "yes") {
            if (testDefault == "yes") {
              printf("(728) %d: firstPart is yes\n", NR);
              printf("(729) %d: position of colon is=%d\n", NR, position);
            }
            if (position == 1) {
              partBeforeColon = "";
              lengthOfRestOfTheLine = length(restOfTheLine);
              if (lengthOfRestOfTheLine == 1) {
                if (mode == "check") {
                  if (testDefault == "yes") {
                    printf("(737) EE ");
                  }
                  printf("%d: no member found after colon >%s<\n", NR, theLine);
                }
              }
              t1 = substr(restOfTheLine, 2);
              partWithoutColon = FirstAwayTrim(t1);
              if (testDefault == "yes") {
                printf("(745) %d: partWithoutColon >%s<\n", NR, partWithoutColon);
              }
            } else {
              someMore = index(theLine, restOfTheLine);
              if (testDefault == "yes") {
                printf("(750) %d: someMore=%d\n", NR, someMore);
              }
              if (mode == "check") {
                if (testDefault == "yes") {
                  printf("(754) EE ");
                }
                printf("%d: initialization colon found at %d >%s<\n", NR, position + someMore, theLine);
                printf("%d: should be at the next line.\n", NR);
              }
              #partBeforeColon = substr(restOfTheLine, 1, position - 1);
              partBeforeColon = substr(theLine, 1, position + someMore - 2);
              t1 = substr(restOfTheLine, position + 1);
              partWithoutColon = FirstAwayTrim(t1);
            }
            position = 0;
            firstPart = "no";
          } else {
            if (testDefault == "yes") {
              printf("(768) %d: firstPart is no\n", NR);
            }
            lengthOfRestOfTheLine = length(restOfTheLine);
            lastLetter = substr(restOfTheLine, lengthOfRestOfTheLine,1);
            if (testDefault == "yes") {
              printf("(773) %d: lastLetter >%s<\n", NR, lastLetter);
            }
            if (lastLetter == ",") {
              if (testDefault == "yes") {
                printf("(777) %d: lastLetter >%s<\n", NR, lastLetter);
              }
              if (lengthOfRestOfTheLine == 1) {
                if (mode == "check") {
                  if (testDefault == "yes") {
                    printf("(782) EE ");
                  }
                  printf("%d: no member found after comma >%s<\n", NR, theLine);
                }
              } else {
                if (testDefault == "yes") {
                  printf("(788) EE ");
                }
                printf("%d: Comma at the end of initialization found >%s<\n", NR, theLine);
                printf("%d: should be at the beginning of the next line.\n", NR);
              }
            }
            t2 = FirstAwayTrim(restOfTheLine);
            partWithoutColon = partWithoutColon " " t2;
            if (testDefault == "yes") {
              printf("(797) %d: partWithoutColon >%s<\n", NR, partWithoutColon);
            }
          }
          if (mode == "check") {
            if (testDefault == "yes") {
              printf("(802) %d: Call SplitComma\n", NR);
            }
            ##numberOfParts = SplitComma(partWithoutColon, parts1);
            numberOfParts = SplitComma(restOfTheLine, parts1);
            if (testDefault == "yes") {
              printf("(807) %d: numberOfParts=%d\n", NR, numberOfParts);
              if (numberOfParts > 0) {
                for (i = 1; i <= numberOfParts; i++) {
                  printf("(810) %d: parts1[%d]>%s<\n", NR, i, parts1[i]);
                }
              }
            }
            if (numberOfParts > 1) {
              if (testDefault == "yes") {
                printf("(816) EE ");
              }
              printf("%d: too many initializations found in one line >%s<\n", NR, theLine);
              printf("%d: should be only one per line.\n", NR);
            }
          }
          if (testDefault == "yes") {
            printf("(823) %d: partBeforeColon >%s<\n", NR, partBeforeColon);
            printf("(824) %d: partWithoutColon >%s<\n", NR, partWithoutColon);
          }
        }
      }
      if (testDefault == "yes") {
        printf("(829) %d: colonFound >%s<\n", NR, colonFound);
        printf("(830) %d: questionFound >%s<\n", NR, questionFound);
        printf("(831) %d: endOfInitializationFound >%s<\n", NR, endOfInitializationFound);
        printf("(832) %d: partBeforeColon >%s<\n", NR, partBeforeColon);
        printf("(833) %d: partWithoutColon >%s<\n", NR, partWithoutColon);
      }
      if (colonFound == "yes") {
          if (endOfInitializationFound == "yes") {
            if (mode == "change") {
              if (testDefault == "yes") {
                printf("(839) %d: partBeforeColon >%s<\n", NR, partBeforeColon);
                printf("(840) %d: partWithoutColon >%s<\n", NR, partWithoutColon);
              }
              if (partBeforeColon != "") {
                if (testDefault == "yes") {
                  printf("(844) %d: ", NR);
                }
                printf("%s\n", partBeforeColon);
              }
              if (testDefault == "yes") {
                printf("(849) %d: Call SplitComma\n", NR);
              }
              numberOfParts = SplitComma(partWithoutColon, parts2);
              if (testDefault == "yes") {
                printf("(853) %d: numberOfParts=%d\n", NR, numberOfParts);
                for (i= 1; i <= numberOfParts; i++) {
                  temp = parts2[i];
                  printf("(856) %d: part2[%d] >%s<\n", NR, i, temp);
                }
              }
              indent = "";
              for (i= 1; i < someMore; i++) {
                indent = indent " ";
              }
              for (i= 1; i <= numberOfParts; i++) {
                temp = parts2[i];
                if(testDefault == "yes") {
                  printf("(866) %d: ", NR);
                }
                printf("%s    ", indent);
                if (i == 1) {
                  printf(":");
                } else {
                  printf(",");
                }
                printf(" %s\n", temp);
              }
              printf("%s\n", leftBrace);
            }
            # setup for the next time
            colonFound = "no";
            questionFound = "no";
            endOfInitializationFound = "no";
            firstPart = "yes";
            partBeforeColon = "";
            partWithoutColon = "";
          } else {
            # NO end Of Initialization Found
          }
      } else {
        # NO colonFound
        if (mode == "change") {
          if (testDefault == "yes") {
            printf("(892) %d", NR);
          }
          printf("%s\n", theLine);
        }
      }
    }
  }
}
