BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print ".awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  namespaceWithBrace = "yes";
  lineBefore = "";

  testIt ="no";
  #testIt ="yes";
  testItNS ="no";
  #testItNS ="yes";
} # end of BEGIN

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                              # separate local variables from real  parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, Input Line >%s<\n", NR, theLine);
  }
  if (testItNS == "yes") {
    printf("\n%d, Input Line >%s<\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(63)(%d)=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(94)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(99)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(103)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(109)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(119)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(126)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(130)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(165)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(170)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(174)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(180)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(190)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(195)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(199)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(205)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(215)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(222)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(237)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(244)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(251)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(258)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(263)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(267)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(275)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(281)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(313)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(318)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(325)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(332)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(337)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(341)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(347)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(378)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(383)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(390)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(397)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(402)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(406)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(412)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(420)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(433) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }

  # look for namespace xyz {
  if (namespaceWithBrace == "yes") {
    placeOfNamespace = index(workLine, "namespace" );
    if (testItNS == "yes") {
      printf("(445) %d: placeOfNamespace=%d\n", NR, placeOfNamespace);
    }
    if (placeOfNamespace > 0) {
      placeOfUsing = index(workLine, "using namespace" );
      if (placeOfUsing == 0) {
        # look for last character of the line
        lengthOfTheLine = length(workLine);
        lastCharacter = substr(workLine, lengthOfTheLine, 1);
        if (lastCharacter != leftBrace) {
          namespaceWithBrace = "no";
          if (mode == "check") {
            if (testItNS == "yes") {
              printf("(457) %d: ", NR);
            }
            printf("%d: namespace without leftBrace at end of line: %s\n", NR, theLine);
          }
          # look for leftBrace at the next line
          lineBefore = theLine;
        } else {
          # normal line "namespace xyz leftBrace"
          if (mode == "change") {
            if (testItNS == "yes") {
              printf("(467) %d: ", NR);
            }
            printf("%s\n", theLine);
          }
        }
      } else {
        # normal line "using namespace xyz;"
        if (mode == "change") {
          if (testItNS == "yes") {
            printf("(476) %d: ", NR);
          }
          printf("%s\n", theLine);
        }
      }
    } else {
      # normal line
      if (mode == "change") {
        if (testItNS == "yes") {
          printf("(485) %d: ", NR);
        }
        printf("%s\n", theLine);
      }
    }
  } else {
    # we look for leftBrace at the next line
    firstCharacter = substr(workLine, 1, 1);
    if (firstCharacter == leftBrace) {
      if (mode == "change") {
        if (testItNS == "yes") {
          printf("(496) %d: ", NR);
        }
        printf("%s\n", lineBefore);
        if (testItNS == "yes") {
          printf("(500) %d: ", NR);
        }
        printf("%s\n", leftBrace);
      }
      namespaceWithBrace = "yes";
    } else {
      printf("This should never happens, as the source was compiled without error\n");
    }
  }
}
