BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "SpaceInArray.awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  switchState = normalLine;
 
  blockNumber = 0;
  blockStatus = "not_defined"
              # "BeginFound"
              # "EndFound"

  leftBrace  = "{";
  rightBrace = "}";

  fourSpace = "    ";

  testIt_f = "no";
  #testIt_f = "yes";
  testIt = "no";
  #testIt = "yes";
  testItSwitch ="no";
  #testItSwitch ="yes";
} # end of BEGIN

function RIndex(inLine,whatChar,    i, lengthOfTheInLine, character, lastPLace)
{                              # separate local variables from real parameters by extra spaces
  # looking for first "whatChar" character back from the end of the string "inLine"
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  lastPlace = 0;
  for (i = lengthOfTheInLine; i >= 1; i--) {
    character = substr(inLine, i, 1);
    if (character == whatChar) {
      lastPlace = i;
      break;
    }
  }
  return lastPlace;
}

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function PutIndentation(lengthOfIndentation,          i)
{                                # separate local variables from real  parameters  by  extra  spaces
  indentation = "";
  for (i = 1; i<= lengthOfIndentation; i++) {
    indentation = sprintf("%s ", indentation);
  }
}

function PutOldLine(oneOldLine, what)
{
  # increment the buffer with one line. what is a debug variable
  oldLineNR = oldLineNR + 1;
  theOldLines[oldLineNR] = oneOldLine;
  whatOldLines[oldLineNR] = what;
}

function GetOldLine()
{
  # decrement the buffer with one line.
  saveTheLine = theOldLines[oldLineNR];
  oldLineNR = oldLineNR - 1;
  return saveTheLine;
}

function FlushTheOldLines(where,               i)
{                                # separate local variables from real  parameters  by  extra  spaces
  
  # indentation, oldLineNR, theOldLines, whatOldLines are global variables
  if (oldLineNR > 0) {
    # old line(s) is/are present
    for (i = 1; i <= oldLineNR ; i++) {
      if (testIt_f == "yes") {
        printf("f-Normal[%d](%d)(%d)=", i, where, whatOldLines[i]);
      }
      if (testIt == "yes") {
        printf("%d============================", whatOldLines[i]);
      }
      printf("%s%s\n", indentation, theOldLines[i]);
    }
  } else {
    if (testIt_f == "yes") {
      printf("f-Normal(%d)=nothing\n", where);
    }
  }
  # init the buffer
  oldLineNR = 0;
}

function LookForPunkt(inLine,      lengthOfTheInLine, character, whereIsPunkt)
{                                # separate local variables from real  parameters  by  extra  spaces
  # look for leftBrace after case or default
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  character = substr(inLine, lengthOfTheInLine, 1);
  if (character == ":") {
    return lengthOfTheInLine;
  } else {
    if (testIt == "yes") {
      printf("look back to the :\n");
    }
    # look back to the :
    whereIsPunkt = RIndex(inLine, ":");
    if (whereIsPunkt > 0) {
      return whereIsPunkt;
    } else {
      return 0;
    }
  }
}

{ # do the job
  theLine = $0;
  if (testIt == "yes" ||
      testItSwitch == "yes") {
    printf("(157) %d:\n", NR);
    printf("(158) %d: theLine >%s<\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("(166) %d: switchState=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("(168) %d: normalLine\n", NR); break;
      case 1: printf("(169) %d: comment_1_BeginIsFound\n", NR); break;
      case 2: printf("(170) %d: comment_1_EndIsFound\n", NR); break;
      case 3: printf("(171) %d: comment_2_BeginIsFound\n", NR); break;
      case 4: printf("(172) %d: string_1_BeginIsFound\n", NR); break;
      case 5: printf("(173) %d: string_1_EndIsFound\n", NR); break;
      case 6: printf("(174) %d: string_2_BeginIsFound\n", NR); break;
      case 7: printf("(175) %d: string_2_EndIsFound\n", NR); break;
      case 8: printf("(176) %d: directiveBeginIsFound\n", NR); break;
      case 9: printf("(177) %d: directiveEndIsFound\n", NR); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("(188) %d: whereIsComment_1= %d\n", NR, whereIsComment_1);
        printf("(189) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        printf("(190) %d: whereIsString_1= %d\n", NR, whereIsString_1);
        printf("(191) %d: whereIsString_2= %d\n", NR, whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("(197) %d: switchState changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(202) %d: partBeforeComment >>%s<<\n", NR, partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(206) %d: workLine >>%s<<:\n", NR, workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("(212) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("(217) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("(222) %d: switchState changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          lengthOfThePartBefore = length(partBeforeComment);
          letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          while (letter == " ") {
            tempBuffer = substr(partBeforeComment, 1, lengthOfThePartBefore- 1);
            partBeforeComment = tempBuffer;
            lengthOfThePartBefore = length(partBeforeComment);
            letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          }
          if (testIt == "yes") {
            printf("(236) %d: partBeforeComment >>%s<<\n", NR, partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(240) %d: workLine >>%s<<:\n", NR, workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("(245) %d: whereIsString_1= %d\n", NR, whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("(249) %d: whereIsString_2= %d\n", NR, whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("(253) %d: choosing ...\n", NR);
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("(267) %d: after choosing: whereIsString_1= %d\n", NR, whereIsString_1);
          }
          if (testIt == "yes") {
            printf("(270) %d: after choosing: whereIsString_2= %d\n", NR, whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("(275) %d: switchState changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(280) %d: partBeforeString >>%s<<\n", NR, partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(284) %d: workLine >>%s<<:\n", NR, workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("(290) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 =  index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("(295) %d: whereIsString_2= %d\n",  NR, whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("(300) %d: switchState changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(305) %d: partBeforeString >>%s<<\n", NR, partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(309) %d: workLine >>%s<<:\n", NR, workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("(315) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("(320) %d: whereIsDirective= %d\n", NR, whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("(325) %d: switchState changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("(332) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("(347) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("(354) %d: switchState changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(361) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(368) %d: workLine >>%s<<:\n", NR, workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(373) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(377) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("(385) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("(391) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("(392) %d: ... looking for \"\n", NR);
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(401) %d: look:i=%d, character=:%s:\n", NR, i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("(406) %d: found \"\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(414) %d: found \\ escape character %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(423) %d: whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(428) %d: switchState changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(435) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(442) %d: workLine >>%s<<:\n", NR, workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(447) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(451) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("(457) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(466) %d: look:i=%d, character=:%s:\n", NR, i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("(471) %d: found '\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(479) %d: found \\ escape character %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(488) %d: whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(493) %d: switchState changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(500) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(507) %d: workLine >>%s<<:\n", NR, workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(512) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(516) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("(522) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("(530) %d: switchState changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(543) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(548) %d: (nach while)workLine >>%s<<\n", NR, workLine);
  }

  # look for "[<Space>" and "<Space>]"
  theOutLine = FirstSpaceAway(workLine);

  if (testItSwitch == "yes") {
    printf("(555) %d: theOutLine >%s<\n", NR, theOutLine);
  }
  # look for "[ "
  whereIs = index(theOutLine, "[ ");
  if (whereIs > 0) {
    if (mode == "check") {
      printf("%d: [<SPACE> found: >%s<\n", NR, theLine);
    }
    if (mode == "change") {
      gsub("\\[ ", "[", theLine);
    }
  }
  # look for " ]"
  whereIs = index(theOutLine, " ]");
  if (whereIs > 0) {
    if (mode == "check") {
      printf("%d: <SPACE>] found: >%s<\n", NR, theLine);
    }
    if (mode == "change") {
      gsub(" ]", "]", theLine);
    }
  }
  printf("%s\n", theLine);
}
