BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "Switch-Brace.awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }
  if (mode == "change") {
    print "Switch-Brace.awk: mode change not yet implemented";
    exit;
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  S_normalLine        = 10;
  S_switchIsFound     = 11;
  S_caseIsFound       = 12;
  S_defaultIsFound    = 13;
  S_leftBraceIsFound  = 14;
  S_endOfBlockIsFound = 15;

  S_switchState = S_normalLine;
  switchState = normalLine;
 
  blockNumber = 0;
  blockStatus = "not_defined"
              # "BeginFound"
              # "EndFound"

  leftBrace  = "{";
  rightBrace = "}";

  fourSpace = "    ";

  testIt_f = "no";
  #testIt_f = "yes";
  testIt = "no";
  #testIt = "yes";
  testItSwitch ="no";
  #testItSwitch ="yes";
} # end of BEGIN

function RIndex(inLine,whatChar,    i, lengthOfTheInLine, character, lastPLace)
{                              # separate local variables from real parameters by extra spaces
  # looking for first "whatChar" character back from the end of the string "inLine"
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  lastPlace = 0;
  for (i = lengthOfTheInLine; i >= 1; i--) {
    character = substr(inLine, i, 1);
    if (character == whatChar) {
      lastPlace = i;
      break;
    }
  }
  return lastPlace;
}

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function PutIndentation(lengthOfIndentation,          i)
{                                # separate local variables from real  parameters  by  extra  spaces
  indentation = "";
  for (i = 1; i<= lengthOfIndentation; i++) {
    indentation = sprintf("%s ", indentation);
  }
}

function PutOldLine(oneOldLine, what)
{
  # increment the buffer with one line. what is a debug variable
  oldLineNR = oldLineNR + 1;
  theOldLines[oldLineNR] = oneOldLine;
  whatOldLines[oldLineNR] = what;
}

function GetOldLine()
{
  # decrement the buffer with one line.
  saveTheLine = theOldLines[oldLineNR];
  oldLineNR = oldLineNR - 1;
  return saveTheLine;
}

function FlushTheOldLines(where,               i)
{                                # separate local variables from real  parameters  by  extra  spaces
  
  # indentation, oldLineNR, theOldLines, whatOldLines are global variables
  if (oldLineNR > 0) {
    # old line(s) is/are present
    for (i = 1; i <= oldLineNR ; i++) {
      if (testIt_f == "yes") {
        printf("f-Normal[%d](%d)(%d)=", i, where, whatOldLines[i]);
      }
      if (testIt == "yes") {
        printf("%d============================", whatOldLines[i]);
      }
      printf("%s%s\n", indentation, theOldLines[i]);
    }
  } else {
    if (testIt_f == "yes") {
      printf("f-Normal(%d)=nothing\n", where);
    }
  }
  # init the buffer
  oldLineNR = 0;
}

function LookForPunkt(inLine,      lengthOfTheInLine, character, whereIsPunkt)
{                                # separate local variables from real  parameters  by  extra  spaces
  # look for leftBrace after case or default
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  character = substr(inLine, lengthOfTheInLine, 1);
  if (character == ":") {
    return lengthOfTheInLine;
  } else {
    if (testIt == "yes") {
      printf("look back to the :\n");
    }
    # look back to the :
    whereIsPunkt = RIndex(inLine, ":");
    if (whereIsPunkt > 0) {
      return whereIsPunkt;
    } else {
      return 0;
    }
  }
}

{ # do the job
  theLine = $0;
  if (testIt == "yes" ||
      testItSwitch == "yes") {
    printf("(168) %d:\n", NR);
    printf("(169) %d: theLine >%s<\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("(177) %d: switchState=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("(179) %d: normalLine\n", NR); break;
      case 1: printf("(180) %d: comment_1_BeginIsFound\n", NR); break;
      case 2: printf("(181) %d: comment_1_EndIsFound\n", NR); break;
      case 3: printf("(182) %d: comment_2_BeginIsFound\n", NR); break;
      case 4: printf("(183) %d: string_1_BeginIsFound\n", NR); break;
      case 5: printf("(184) %d: string_1_EndIsFound\n", NR); break;
      case 6: printf("(185) %d: string_2_BeginIsFound\n", NR); break;
      case 7: printf("(186) %d: string_2_EndIsFound\n", NR); break;
      case 8: printf("(187) %d: directiveBeginIsFound\n", NR); break;
      case 9: printf("(188) %d: directiveEndIsFound\n", NR); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("(199) %d: whereIsComment_1= %d\n", NR, whereIsComment_1);
        printf("(200) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        printf("(201) %d: whereIsString_1= %d\n", NR, whereIsString_1);
        printf("(202) %d: whereIsString_2= %d\n", NR, whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("(208) %d: switchState changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(213) %d: partBeforeComment >>%s<<\n", NR, partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(217) %d: workLine >>%s<<:\n", NR, workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("(223) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("(228) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("(233) %d: switchState changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          lengthOfThePartBefore = length(partBeforeComment);
          letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          while (letter == " ") {
            tempBuffer = substr(partBeforeComment, 1, lengthOfThePartBefore- 1);
            partBeforeComment = tempBuffer;
            lengthOfThePartBefore = length(partBeforeComment);
            letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          }
          if (testIt == "yes") {
            printf("(247) %d: partBeforeComment >>%s<<\n", NR, partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(251) %d: workLine >>%s<<:\n", NR, workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("(256) %d: whereIsString_1= %d\n", NR, whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("(260) %d: whereIsString_2= %d\n", NR, whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("(264) %d: choosing ...\n", NR);
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("(278) %d: after choosing: whereIsString_1= %d\n", NR, whereIsString_1);
          }
          if (testIt == "yes") {
            printf("(281) %d: after choosing: whereIsString_2= %d\n", NR, whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("(286) %d: switchState changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(291) %d: partBeforeString >>%s<<\n", NR, partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(295) %d: workLine >>%s<<:\n", NR, workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("(301) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 =  index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("(306) %d: whereIsString_2= %d\n",  NR, whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("(311) %d: switchState changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(316) %d: partBeforeString >>%s<<\n", NR, partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(320) %d: workLine >>%s<<:\n", NR, workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("(326) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("(331) %d: whereIsDirective= %d\n", NR, whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("(336) %d: switchState changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("(343) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("(358) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("(365) %d: switchState changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(372) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(379) %d: workLine >>%s<<:\n", NR, workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(384) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(388) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("(396) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("(402) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("(403) %d: ... looking for \"\n", NR);
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(412) %d: look:i=%d, character=:%s:\n", NR, i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("(417) %d: found \"\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(425) %d: found \\ escape character %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(434) %d: whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(439) %d: switchState changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(446) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(453) %d: workLine >>%s<<:\n", NR, workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(458) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(462) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("(468) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(477) %d: look:i=%d, character=:%s:\n", NR, i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("(482) %d: found '\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(490) %d: found \\ escape character %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(499) %d: whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(504) %d: switchState changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(511) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(518) %d: workLine >>%s<<:\n", NR, workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(523) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(527) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("(533) %d: restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("(541) %d: switchState changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(554) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(559) %d: (nach while)workLine >>%s<<\n", NR, workLine);
  }

  # look for switch and brace(s)
  theOutLine = FirstSpaceAway(workLine);

  if (testItSwitch == "yes") {
    printf("(566) %d: S_switchState=%d\n", NR, S_switchState);
    switch (S_switchState) {
    case 10: printf("(568) %d: S_normalLine\n", NR); break;
    case 11: printf("(569) %d: S_switchIsFound\n", NR); break;
    case 12: printf("(570) %d: S_caseIsFound\n", NR); break;
    case 13: printf("(571) %d: S_defaultIsFound\n", NR); break;
    case 14: printf("(572) %d: S_leftBraceIsFound\n", NR); break;
    case 15: printf("(573) %d: S_endOfBlockIsFound\n", NR); break;
    }
    printf("(575) %d: ****************************************************blockNumber=%d\n", NR, blockNumber);
    if (blockNumber < 0) {
      exit;
    }
  }
  switch (S_switchState) {
  case 10: # S_normalLine:
    # look for switch [1]
    if (testItSwitch == "yes") {
      printf("(584) %d: look for switch (\n", NR);
    }
    whereIsSwitch = index(theOutLine, "switch (");
    if (whereIsSwitch == 1) {
      if (testItSwitch == "yes") {
        printf("(589) %d: switch found\n", NR);
      }
      # check the last character
      lengthOfLine = length(theOutLine);
      last = substr(theOutLine, lengthOfLine, 1);
      if (testItSwitch == "yes") {
        printf("(595) %d: last >%s<\n", NR, last);
      }
      if (last != leftBrace) {
        if (testItSwitch == "yes") {
          printf("(599) %d: ", NR);
        }
        printf("a left Brace is missing at the end of the line. %s\n", theLine);
        exit;
      }
      if (testItSwitch == "yes") {
        printf("(605) %d: S_switchState changed to S_switchIsFound\n", NR);
      }
      S_switchState = S_switchIsFound;
      blockNumber = blockNumber + 1;
      if (testItSwitch == "yes") {
        printf("(610) %d: ****************************************************blockNumber=%d\n", NR, blockNumber);
        printf("(611) %d: look for the position of switch (\n", NR);
      }
      whereIsSwitch2 = index(theOutLine, "switch (");
      lengthOfBeforeSwitch = whereIsSwitch2 - 1;
      # build the indentation
      PutIndentation(lengthOfBeforeSwitch);
    }
    #if (mode == "change") {
    #  if (testItSwitch == "yes") {
    #    printf("(620) %d: n-Normal====================", NR);
    #  }
    #  printf("%s\n", theLine);
    #}
    break;
  case 11: # S_switchIsFound
    # look for case, default, rightBrace, break, return
    # look for case [2]
    if (testItSwitch == "yes") {
      printf("(629) %d: look for case \n", NR);
    }
    whereIsCase = index(theOutLine, "case ");
    if (whereIsCase == 1) {
      # init the buffer
      oldLineNR = 0;
      if (testItSwitch == "yes") {
        printf("(636) %d: case found\n", NR);
      }
      if (mode == "check") {
        theOldLine = theLine;
        theOldNR = NR;
      }
      #if (mode == "change") {
      #  gggg breakAfterBlockFound = "no";
      #  PutOldLine(theOutLine, 165)
      #}
      if (testItSwitch == "yes") {
        printf("(647) %d: S_switchState changed to S_caseIsFound\n", NR);
      }
      S_switchState = S_caseIsFound;
    } else {
      # look for default [3]
      if (testItSwitch == "yes") {
        printf("(653) %d: case not found\n", NR);
        printf("(654) %d: look for default\n", NR);
      }
      whereIsDefault = index(theOutLine, "default");
      if (whereIsDefault == 1) {
        if (testItSwitch == "yes") {
          printf("(659) %d: default found\n", NR);
        }
        if (mode == "check") {
          theOldLine = theLine;
          theOldNR = NR;
        }
        #if (mode == "change") {
        #  PutOldLine(theOutLine, 182)
        #}
        if (testItSwitch == "yes") {
          printf("(669) %d: S_switchState changed to S_defaultIsFound\n", NR);
        }
        S_switchState = S_defaultIsFound;
      } else {
        # look for rightBrace [4]
        if (testItSwitch == "yes") {
          printf("(675) %d: default not found\n", NR);
          printf("(676) %d: look for rightBrace\n", NR);
        }
        whereIsRightBrace = index(theOutLine, rightBrace);
        if (whereIsRightBrace == 1) {
          #if (mode == "change") {
          #  PutOldLine(theOutLine, 199)
          #  FlushTheOldLines(682);
          #  if (testItSwitch == "yes") {
          #    printf("(684) %d: S_switchState=%d\n", NR, S_switchState);
          #  }
          #}
          if (blockNumber == 1) {
            S_switchState = S_normalLine;
            blockNumber = 0;
            if (testItSwitch == "yes") {
              printf("(691) %d: ****************************************************blockNumber=%d\n", NR, blockNumber);
            }
          }
        } else {
          # look for break [4]
          if (testItSwitch == "yes") {
            printf("(697) %d: rightBrace not found\n", NR);
            printf("(698) %d: look for break\n", NR);
          }
          whereIsBreak = index(theOutLine, "break");
          if (whereIsBreak == 1) {
              if (testItSwitch == "yes") {
                printf("(703) %d: break found ERROR\n", NR);
              }
              printf("%d: %s\n", NR, theLine);
              printf("%d: break should be placed before the end of the block\n", NR);
          } else {
            # look for return [4]
            if (testItSwitch == "yes") {
              printf("(710) %d: break not found\n", NR);
              printf("(711) %d: look for return\n", NR);
            }
            whereIsReturn = index(theOutLine, "return");
            if (whereIsReturn == 1) {
                if (testItSwitch == "yes") {
                  printf("(716) %d: return found ERROR\n", NR);
                }
                printf("%d: %s\n", NR, theLine);
                printf("%d: return should be placed before the end of the block\n", NR);
            } else {
              if (testItSwitch == "yes") {
                printf("(722) %d: return not found\n", NR);
                printf("(723) %d: S_switchState=%d\n", NR, S_switchState);
              }
              #if (mode == "change") {
              #  FlushTheOldLines(726);
              #  if (testItSwitch == "yes") {
              #    printf("(728) %d: n-Normal(2b)=", NR);
              #  }
              #  printf("%s\n", theLine);
              #}
            }
          }
        }
      }
    }
    switch (S_switchState) {
    case 12: # S_caseIsFound
    case 13: # S_defaultIsFound
      # look for leftBrace after case or default
      if (testItSwitch == "yes") {
        printf("(742) %d: look for leftBrace after case or default at the same line\n", NR);
      }
      whereIsPunkt = LookForPunkt(theOutLine);
      if (whereIsPunkt > 0) {
        if (testItSwitch == "yes") {
          printf("(747) %d: Punkt(\":\") found at %d\n",NR , whereIsPunkt);
        }
        lengthOfTheInLine = length(theOutLine);
        if (testItSwitch == "yes") {
          printf("(751) %d: lengthOfTheInLine=%d\n", NR, lengthOfTheInLine);
        }
        if (whereIsPunkt != lengthOfTheInLine) {
          # look for leftBrace [7a]
          if (testItSwitch == "yes") {
            printf("(756) %d: look for leftBrace\n", NR);
          }
          whereIsleftBrace = index(theOutLine, leftBrace);
          if (whereIsleftBrace > 0) {
            blockNumber = blockNumber + 1;
            #gggg endOfBlockFound = "no";
            if (testItSwitch == "yes") {
              printf("(763) %d: leftBrace found, ***********************************blockNumber=%d\n", NR, blockNumber);
            }
            if (testItSwitch == "yes") {
              printf("(766) %d: S_switchState changed to S_leftBraceIsFound\n", NR);
            }
            S_switchState = S_leftBraceIsFound;
          } else {
            if (testItSwitch == "yes") {
              printf("(771) %d: NO leftBrace found\n", NR);
            }
          }
        } else {
          if (testItSwitch == "yes") {
            printf("(776) %d: NO leftBrace found\n", NR);
          }
          ## NO ## FlushTheOldLines(778);
        }
      } else {
        if (testItSwitch == "yes") {
          printf("(782) %d: NO leftBrace found\n", NR);
        }
      }
      break;
    }
    break;
  case 12: # S_caseIsFound
  case 13: # S_defaultIsFound
    # look for default [6]
    if (testItSwitch == "yes") {
      printf("(792) %d: look for default\n", NR);
    }
    whereIsDefault = index(theOutLine, "default");
    if (whereIsDefault == 1) {
      if (testItSwitch == "yes") {
        printf("(797) %d: default found\n", NR);
      }
      if (mode == "check") {
        theOldLine = theLine;
        theOldNR = NR;
      }
      #if (mode == "change") {
      #  PutOldLine(theOutLine, 273)
      #}
      if (testItSwitch == "yes") {
        printf("(807) %d: S_switchState changed to S_defaultIsFound\n", NR);
      }
      S_switchState = S_defaultIsFound;
    } else {
      # look for a new case [5]
      if (testItSwitch == "yes") {
        printf("(813) %d: look for case \n", NR);
      }
      whereIsCase = index(theOutLine, "case ");
      if (whereIsCase == 1) {
        if (testItSwitch == "yes") {
          printf("(818) %d: case found\n", NR);
        }
        if (mode == "check") {
          theOldLine = theLine;
          theOldNR = NR;
        }
        #if (mode == "change") {
        #  PutOldLine(theOutLine, 292)
        #}
        if (testItSwitch == "yes") {
          printf("(828) %d: S_switchState changed to S_caseIsFound\n", NR);
        }
        S_switchState = S_caseIsFound;
      } else {
        # look for rightBrace [9]
        if (testItSwitch == "yes") {
          printf("(834) %d: look for rightBrace\n", NR);
        }
        whereIsRightBrace = index(theOutLine, rightBrace);
        if (whereIsRightBrace == 1) {
          if (testItSwitch == "yes") {
            printf("(839) %d: ******************blockNumber=%d\n", NR, blockNumber);
          }
          if (blockNumber == 1) {
            if (testItSwitch == "yes") {
              printf("(843) %d: S_switchState changed to S_normalLine\n", NR);
            }
            S_switchState = S_normalLine;
          }
          blockNumber = blockNumber - 1;
          if (testItSwitch == "yes") {
            printf("(849) %d: rightBrace found, ******************blockNumber=%d\n", NR, blockNumber);
          }
          #if (mode == "change") {
          #  PutOldLine(theOutLine, 346)
          #  FlushTheOldLines(853);
          #}
        } else {
          # look for break [8]
          if (testItSwitch == "yes") {
            printf("(858) %d: look for break\n", NR);
          }
          whereIsBreak = index(theOutLine, "break");
          if (whereIsBreak == 1) {
            if (testItSwitch == "yes") {
              printf("(863) %d: break found\n", NR);
            }
            #if (mode == "change") {
            #  # prepare the line
            #  theOutLine = fourSpace "break;";
            #  PutOldLine(theOutLine, 318)
            #  FlushTheOldLines(869);
            #}
            if (testItSwitch == "yes") {
              printf("(872) %d: S_switchState changed to S_switchIsFound\n", NR);
            }
            S_switchState = S_switchIsFound;
          } else {
            if (testItSwitch == "yes") {
              printf("(877) %d: look for leftBrace after case or default at the next line\n", NR);
            }
            # look for leftBrace [7b]
            if (testItSwitch == "yes") {
              printf("(881) %d: look for leftBrace\n", NR);
            }
            whereIsleftBrace = index(theOutLine, leftBrace);
            #if (whereIsleftBrace == 1) 
            if (whereIsleftBrace > 0) {
              blockNumber = blockNumber + 1;
              if (testItSwitch == "yes") {
                printf("(888) %d: leftBrace found >>%s<<, ******************blockNumber=%d\n", NR, theLine, blockNumber);
              }
              if (testItSwitch == "yes") {
                printf("(891) %d: S_switchState changed to S_leftBraceIsFound\n", NR);
              }
              S_switchState = S_leftBraceIsFound;
              if (blockNumber == 1) {
                # left brace found at the next line
                # the left brace should be placed at the end of the line before
                if (mode == "check") {
                  printf("%d:%s\n", theOldNR, theOldLine);
                  printf("%d:%s\n", NR, theLine);
                  printf("%d: left brace found at the next line\n", NR);
                  printf("%d: the left brace should be placed at the end of the line before\n", NR);
                  exit;
                }
                if (testItSwitch == "yes") {
                  exit;
                }
                #if (mode == "change") {
                #  # prepare the line
                #  theOutLine = GetOldLine(909) " " leftBrace;
                #  if (testItSwitch == "yes") {
                #    printf("(911) %d: the new Line:%s\n", NR, theOutLine);
                #  }
                #  PutOldLine(theOutLine, 352)
                #  FlushTheOldLines(914);
                #}
              }
            } else {
              # other statment(s) [10]
              #if (mode == "change") {
              #  # prepare the line
              #  theOutLine = FirstSpaceAway(theLine);
              #  theOutLine = fourSpace theOutLine;
              #  PutOldLine(theOutLine, 360)
              #  FlushTheOldLines(924);
              #}
            }
          }
        }
      }
    }
    break;
  case 14: # S_leftBraceIsFound
    if (testItSwitch == "yes") {
      printf("(934) %d: this is a new Block\n", NR);
    }
    if (testItSwitch == "yes") {
      printf("(937) %d: S_switchState=%d\n", NR, S_switchState);
      switch (S_switchState) {
      case 10: printf("(939) %d: S_normalLine\n", NR); break;
      case 11: printf("(940) %d: S_switchIsFound\n", NR); break;
      case 12: printf("(941) %d: S_caseIsFound\n", NR); break;
      case 13: printf("(942) %d: S_defaultIsFound\n", NR); break;
      case 14: printf("(943) %d: S_leftBraceIsFound\n", NR); break;
      case 15: printf("(944) %d: S_endOfBlockIsFound\n", NR); break;
      }
    }
    # look for rightBrace [11]
    if (testItSwitch == "yes") {
      printf("(949) %d: look for rightBrace\n", NR);
    }
    whereIsRightBrace = index(theOutLine, rightBrace);
    if (testItSwitch == "yes") {
      printf("(953) %d: ****************************************************blockNumber=%d\n", NR, blockNumber);
    }
    if (whereIsRightBrace == 1) {
      blockNumber = blockNumber - 1;
      if (testItSwitch == "yes") {
        printf("(958) %d: rightBrace found, **********************************blockNumber=%d\n", NR, blockNumber);
      }
      # look for a new block begin such as
      #   } else if (xxxxxxxxx == yyyyyyy) {
      restOfTheLine = substr(theOutLine, 2);
      lengthOfRestOfTheLine = length(restOfTheLine);
      if (lengthOfRestOfTheLine > 0) {
        if (testItSwitch == "yes") {
          printf("(966) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
        if (testItSwitch == "yes") {
          printf("(969) %d: look for a new block begin\n", NR);
        }
        if (testItSwitch == "yes") {
          printf("(972) %d: look for a new leftBrace\n", NR);
        }
        whereIsleftBrace = index(restOfTheLine, leftBrace);
        if (whereIsleftBrace > 0) {
          blockNumber = blockNumber + 1;
          if (testItSwitch == "yes") {
            printf("(978) %d: new leftBrace found, ******************blockNumber=%d\n", NR, blockNumber);
          }
        }
      }
      if (blockNumber == 1) {
        if (testItSwitch == "yes") {
          #printf("(984) %d: S_switchState changed to S_endOfBlockIsFound\n", NR);
          printf("(985) %d: S_switchState changed to S_switchIsFound\n", NR);
        }
        #S_switchState = S_endOfBlockIsFound;
        S_switchState = S_switchIsFound;
        #gggg endOfBlockFound = "yes";
        # test the indentation
        ##if (testItSwitch == "yes") {
        ##  printf("(992) %d: look for rightBrace\n", NR);
        ##}
        ##whereIsRightBrace = index(theOutLine, rightBrace);
        ##if (testItSwitch == "yes") {
        ##  printf("(996) %d: rightBrace at the end of Block found %d\n", NR, whereIsRightBrace);
        ##  printf("(997) %d: lengthOfBeforeSwitch=%d\n", NR, lengthOfBeforeSwitch);
        ##}
      }
      #if (mode == "change") {
      #  if (testItSwitch == "yes") {
      #    printf("(1002) %d: breakAfterBlockFound at 403:%s\n", breakAfterBlockFound);
      #  }
      #  if (gggg breakAfterBlockFound == "no") {
      #    PutOldLine(rightBrace, 406)
      #  }
      #}
    } else {
      # other statment(s) [12]
      # here!!
      # look for leftBrace [], maybe a "if" command
      if (testItSwitch == "yes") {
        printf("(1013) %d: look for leftBrace\n", NR);
      }
      whereIsleftBrace = index(theOutLine, leftBrace);
      if (whereIsleftBrace > 0) {
        blockNumber = blockNumber + 1;
        if (testItSwitch == "yes") {
          printf("(1019) %d: leftBrace found, **********************************blockNumber=%d\n", NR, blockNumber);
        }
      }
      #if (mode == "change") {
      #  # prepare the line
      #  theOutLinePrepared = FirstSpaceAway(theLine);
      #  theOutLinePrepared = fourSpace theOutLinePrepared;
      #  PutOldLine(theOutLinePrepared, 414)
      #  FlushTheOldLines(1027);
      #}
    }
    break;
  case 15: # S_endOfBlockIsFound
    if (testItSwitch == "yes") {
      printf("(1033) %d: theOutLine >%s<\n", NR, theOutLine);
    }
    #gggg breakAfterBlockFound = "no";
    # look for break [13]
    if (testItSwitch == "yes") {
      printf("(1038) %d: look for break\n", NR);
    }
    whereIsBreak = index(theOutLine, "break");
    if (whereIsBreak == 1) {
      if (endOfBlockFound == "no") {
        #gggg
        breakAfterBlockFound = "yes";
        if (testItSwitch == "yes") {
          printf("(1046) %d: breakAfterBlockFound >%s<\n", NR, breakAfterBlockFound);
        }
        if (mode == "check") {
          printf("%d:%s\n", NR, theLine);
          if (testItSwitch == "yes") {
            printf("(1051) ");
          }
          printf("%d: break after a block found\n", NR);
          if (testItSwitch == "yes") {
            printf("(1055) ");
          }
          printf("%d: break should be placed before the end of the block\n", NR);
          exit;
        }
        #if (mode == "change") {
        #  if (testItSwitch == "yes") {
        #    printf("(1062) %d: Changed:\n", NR);
        #  }
        #  # a line we don't need
        #  temp = GetOldLine(1065);
        #  PutOldLine("    break;", 444)
        #  PutOldLine(rightBrace, 445)
        #  FlushTheOldLines(1068);
        #  #gggg breakAfterBlockFound = "no";
        #}
      }
      if (testItSwitch == "yes") {
        printf("(1073) %d: S_switchState changed to S_switchIsFound\n", NR);
      }
      S_switchState = S_switchIsFound;
    } else {
      if (testItSwitch == "yes") {
        printf("(1078) %d: NO breakAfterBlockFound found\n", NR);
      }
      # look for return [13xxx]
      if (testItSwitch == "yes") {
        printf("(1082) %d: look for return\n", NR);
      }
      whereIsReturn = index(theOutLine, "return");
      if (whereIsReturn == 1) {
        #gggg
        breakAfterBlockFound = "yes";
        if (testItSwitch == "yes") {
          printf("(1089) %d: ReturnAfterBlockFound\n", NR);
        }
        if (mode == "check") {
          printf("%d:%s\n", NR, theLine);
          if (testItSwitch == "yes") {
            printf("(1094) ");
          }
          printf("%d: return after a block found\n", NR);
          if (testItSwitch == "yes") {
            printf("(1098) ");
          }
          printf("%d: return should be placed before the end of the block\n", NR);
          exit;
        }
      } else {
        if (testItSwitch == "yes") {
          printf("(1105) %d: NO returnAfterBlockFound found\n", NR);
        }
        # look for case [14]
        if (testItSwitch == "yes") {
          printf("(1109) %d: look for case \n", NR);
        }
        whereIsCase = index(theOutLine, "case ");
        if (whereIsCase == 1) {
          if (testItSwitch == "yes") {
            printf("(1114) %d: case after end of block found >%s<\n", NR, theLine);
          }
          if (mode == "check") {
            theOldLine = theLine;
            theOldNR = NR;
          }
          #if (mode == "change") {
          #  PutOldLine(theOutLine, 464)
          #}
         if (testItSwitch == "yes") {
           printf("(1124) %d: S_switchState changed to S_caseIsFound\n", NR);
         }
         S_switchState = S_caseIsFound;
        } else {
          # look for default [15]
          if (testItSwitch == "yes") {
            printf("(1130) %d: look for default\n", NR);
          }
          whereIsDefault = index(theOutLine, "default");
          if (whereIsDefault == 1) {
            if (testItSwitch == "yes") {
              printf("(1135) %d: default after a block found\n", NR);
            }
            if (mode == "check") {
              theOldLine = theLine;
              theOldNR = NR;
            }
            #if (mode == "change") {
            #  PutOldLine(theOutLine, 481)
            #}
            if (testItSwitch == "yes") {
              printf("(1145) %d: S_switchState changed to S_defaultIsFound\n", NR);
            }
            S_switchState = S_defaultIsFound;
          } else {
            # look for rightBrace, end of Block [16]
            if (testItSwitch == "yes") {
              printf("(1151) %d: look for rightBrace\n", NR);
            }
            whereIsRightBrace = index(theOutLine, rightBrace);
            if (whereIsRightBrace == 1) {
              blockNumber = blockNumber - 1;
              if (testItSwitch == "yes") {
                printf("(1157) %d: rightBrace found, end of switch, ******************blockNumber=%d\n", NR, blockNumber);
              }
              if (blockNumber == 1) {
                if (testItSwitch == "yes") {
                  printf("(1161) %d: S_switchState changed to S_normalLine\n", NR);
                }
                S_switchState = S_normalLine;
              }
              #if (mode == "change") {
              #  tempOutLine = rightBrace;
              #  if (testItSwitch == "yes") {
              #    printf("(1168) %d: the tempOutLine >%s<\n", NR, tempOutLine);
              #  }
              #  PutOldLine(tempOutLine, 503)
              #  FlushTheOldLines(1171);
              #}
            } else {
              if (testItSwitch == "yes") {
                printf("(1175) %d: S_switchState changed to S_caseIsFound\n", NR);
              }
              S_switchState = S_caseIsFound;
            }
          }
        }
      }
    }
    break;
  default:
    printf("(1185) %d: WRONG VALUE for S_switchState=%d\n", NR, S_switchState);
    exit;
  } # switch (S_switchState)
}
