BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "twoBrace.awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  testIt ="no";
  #testIt ="yes";
  testItTB ="no";
  #testItTB ="yes";
} # end of BEGIN

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                              # separate local variables from real  parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(55)(%d)=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(86)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(91)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(95)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(101)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(111)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          partBeforeComment = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(117)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(121)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(156)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(161)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(165)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(171)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 =  index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n",  whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(181)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(186)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(190)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(196)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(206)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(213)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(228)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(235)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(242)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(249)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(254)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(258)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(266)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(272)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(304)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(309)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(316)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(323)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(328)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(332)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(338)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(369)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(374)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(381)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(388)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(393)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(397)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(403)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(411)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(424) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }

  # looking for leftBrace rightBrace
  if (testItTB == "yes") {
    printf("(434) %d: workLine >>%s<<\n", NR, workLine);
    printf("(435) %d: look for TwoBrace\n", NR);
  }
  if (testItTB == "yes") {
    printf("(438) %d: look for leftBrace ... rightBrace in the same line\n", NR);
  }
  # looking for leftBrace ... rightBrace in the same line
  whereIsLeftBrace = index(workLine, leftBrace);
  if (whereIsLeftBrace > 0) {
    if (testItTB == "yes") {
      printf("(444) %d: leftBrace found\n", NR);
    }
    restOfTheLine = substr(workLine, whereIsLeftBrace + 1);
    if (testIt == "yes") {
      printf("(448) restOfTheLine >>%s<<\n", restOfTheLine);
      printf("(449) %d: look for rightBrace in the same line\n", NR);
    }
    whereIsRightBrace = index(restOfTheLine, rightBrace);
    if (whereIsRightBrace > 0) {
      lengthOfRestOfTheLine = length(restOfTheLine);
      lastLetter = substr(restOfTheLine, lengthOfRestOfTheLine, 1);
      if (testItTB == "yes") {
        printf("(456) %d: lastLetter %s\n", NR, lastLetter);
      }
      if (lastLetter != ";") {
        if (testItTB == "yes") {
          printf("(460) %d: rightBrace in the same line found\n", NR);
          printf("(461) %d: leftBrace ... rightBrace in the same line found\n", NR);
          printf("(462) %d: let have a look to the beginnig of the line\n", NR);
        }
        if (testItTB == "yes") {
          printf("(465) %d: leftBrace found at %d\n", NR, whereIsLeftBrace);
        }
if (mode == "check") {
  printf("%d: leftBrace ... rightBrace in the same line found: %s\n", NR, theLine);
}
        temp = substr(theLine, 1, whereIsLeftBrace - 1);
        partAtTheBegin = TrimLine(temp);
        lengthOfThePart = length(partAtTheBegin);
        if (testItTB == "yes") {
          printf("(474) %d: lengthOfThePart %d\n", NR, lengthOfThePart);
        }
        if (lengthOfThePart == 0) {
          if (testItTB == "yes") {
            printf("(478) %d: In the part before there are only space(s): don't do anything.\n", NR);
          }
          if (mode == "change") {
            printf("%s\n", theLine);
          }
        } else {
          if (mode == "check") {
            printf("%d: leftBrace ... rightBrace in the same line found: %s\n", NR, theLine);
          }
          if (mode == "change") {
            if (testItTB == "yes") {
              printf("(489) A: ");
              printf("%d: leftBrace ... rightBrace: there are many changes to do: %s\n", NR, theLine);
            }
            whereIsLeftBrace2 = index(theLine, leftBrace);
            if (testItTB == "yes") {
              printf("(494) %d: whereIsLeftBrace2>%d<\n", NR, whereIsLeftBrace2);
            }
            temp = substr(theLine, 1, whereIsLeftBrace - 1);
            # remove space(s) at end of the line
            thePartBefore = TrimLine(temp);
            if (testItTB == "yes") {
              printf("(500) %d: thePartBefore>%s<\n", NR, thePartBefore);
              printf("(501) %d: restOfTheLine>%s<\n", NR, restOfTheLine);
            }
            temp = substr(restOfTheLine, 1, whereIsRightBrace - 1);
            # remove space(s) at end of the line
            thePartInTheMiddle = TrimLine(temp);
            lengthOfTheMiddle = length(thePartInTheMiddle);
            if (testItTB == "yes") {
              printf("(508) %d: thePartInTheMiddle>%s<\n", NR, thePartInTheMiddle);
            }
            if (testItTB == "yes") {
              printf("(511) A: ");
            }
            # if there are more than one statement, these would be changed by astyle
            if (lengthOfTheMiddle == 0) {
              printf("%s\n  {\n  }\n", thePartBefore);
            } else {
              printf("%s\n  {\n    %s\n  }\n", thePartBefore, thePartInTheMiddle);
            }
          }
        }
      }
    } else {
      if (mode == "change") {
        if (testItTB == "yes") {
          printf("(525) A: ");
        }
        printf("%s\n", theLine);
      }
    }
  } else {
    if (testItTB == "yes") {
      printf("(532) %d: leftBrace ... rightBrace in the same line not found\n", NR);
    }
    if (mode == "change") {
      if (testItTB == "yes") {
        printf("(536) A: ");
      }
      printf("%s\n", theLine);
    }
  }
}
