#!/bin/bash
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 12 january   2014
# 27 february  2014
#  5 june      2014
# 25 september 2014
#
# where you have store the script and the awk-program
DIR=./
#
numberOfParameter=$#
if [ ${numberOfParameter} -ne 3 ] ;
then
  echo "it must be 3 Parameters"
  exit
fi
#
nameOfTheScript=${0}
#
list=`ls ${1}`
for eachFile in ${list}
do
  if [ -d ${eachFile} ] ;
  then
    # Is a directory
    if [ -r ${eachFile} ] ;
    then
      # is readable
      if [ ${eachFile} == ".git" ] ;
      then
        # no test on .git directory
        exit
      fi
      if [ -a ".no_coding_style" ] 
      then
        #echo "Datei .no_coding_file gefunden"
        exit
      fi
      if [ -a ".no_recursion" ] 
      then
        # do not explore the next directory(ies)
        touch .no_recursion
      else
        cd ${eachFile}
        ${nameOfTheScript} ${1} ${2} ${3} 
        cd ..
      fi
    fi
  else
    if [ ! -e ${eachFile} ] ;
    then
      echo "**no such file "${eachFile}
      # this should not occur!
      exit
    fi
    # It is a file
    do_it="no"
    base_1=`basename ${eachFile} .h`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    base_1=`basename ${eachFile} .cpp`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    if [ ${do_it} == "yes" ] ;
    then
      gawk -f ${DIR}/${2} -v mode=${3} < ${eachFile} > base.tmp
      echo "File:" `pwd`/${eachFile}
      if [ ${3} == "check" ] ;
      then
        # check
        if [ -s base.tmp ] ;
        then
          cat base.tmp
          echo ""
          rm -f base.tmp
        fi
      else
        # change
        if [ -s base.tmp ] ;
        then
          mv base.tmp ${eachFile}
        fi
      fi
    fi
  fi
done
